namespace FreeSwitch.EventSocket.Events.Channel
{
	[EventName("CHANNEL_EXECUTE_COMPLETE")]
    public class ChannelExecuteComplete : ChannelStateEvent
    {
    	public string AppName { get; set; }

    	public string Arguments { get; set; }

    	public override bool ParseCommand(string name, string value)
        {
        	switch (name)
        	{
        		case "application":
        			AppName = value;
        			break;
        		case "application-data":
        			Arguments = value;
        			break;
        		default:
        			return base.ParseCommand(name, value);
        	}

        	return true;
        }

    	public override string ToString()
        {
            return "ExecuteComplete(" + AppName + ", '" + Arguments + "')." + base.ToString();
        }
    }
}

