namespace FreeSwitch.EventSocket.Events.Messaging
{
	/// <summary>
	/// Ask if a user have waiting messages.
	/// </summary>
	[EventName("message-query")]
	public class MessageQuery : Event
	{
		/// <summary>
		/// Gets account (userName@profile) being queried
		/// </summary>
		public string Account { get; set; }

		public override bool ParseCommand(string name, string value)
		{
			if (name == "message-account")
				Account = value;
			else
				return base.ParseCommand(name, value);

			return true;
		}
	}
}